'==============================================================================
' Turtle.bas
' Turtle-Grafik
' Erstellt am 03.07.13
' Letzte Bearbeitung am 11.12.13
'==============================================================================


' Diese Variablen mssen zu Anfang initialisiert werden (TurtleAngle in Grad),
' TurtleX, TurtleY = Pixelkoordinaten (ganzzahlig)
Dim Shared As Double TurtleAngle
Dim Shared As Integer TurtleX, TurtleY


Sub TurtleMove(distance As integer, PenDown As Integer = 1)
  ' Bewegt die Schildkrte um die angegebene Distanz. 
  ' Falls PenDown = 1, wird eine Linie gezeichnet.
  
  Dim As Integer dx, dy
  Const pi = 4 * Atn(1) 
  
  dx = distance * Cos(pi * TurtleAngle / 180)
  dy = -distance * Sin(pi * TurtleAngle / 180)
  If PenDown = 1 Then Line (TurtleX, TurtleY) - (TurtleX + dx, TurtleY + dy)
  TurtleX = TurtleX + dx
  TurtleY = TurtleY + dy
  
End Sub


sub TurtleMoveTo(x As integer, y As integer, PenDown As Integer = 1)
  ' Bewegt die Schildkrte zur Position (x, y).
  ' Falls PenDown = 1, wird eine Linie gezeichnet.
  
  If PenDown = 1 Then Line (TurtleX, TurtleY) - (x, y)
  TurtleX = x
  TurtleY = y
  
End sub


sub TurtleTurn(angle As Double)
  ' Dreht die Richtung am den angegebenen Winkel in Grad. 
  ' angle > 0: Linksdrehung
  ' angle < 0: Rechtsdrehung
  
  TurtleAngle = TurtleAngle + angle
  
End Sub

